
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class StudentsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const students = await db.students.create(
            {
                id: data.id || undefined,
        
        student_number: data.student_number
        ||
        null
            ,
            
        gender: data.gender
        ||
        null
            ,
            
        date_of_birth: data.date_of_birth
        ||
        null
            ,
            
        medical_notes: data.medical_notes
        ||
        null
            ,
            
        enrollment_date: data.enrollment_date
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await students.setUser( data.user || null, {
            transaction,
        });
        
        await students.setSchool( data.school || null, {
            transaction,
        });
        
        await students.setCampus( data.campus || null, {
            transaction,
        });
        

        

        

        return students;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const studentsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                student_number: item.student_number
            ||
            null
            ,
            
                gender: item.gender
            ||
            null
            ,
            
                date_of_birth: item.date_of_birth
            ||
            null
            ,
            
                medical_notes: item.medical_notes
            ||
            null
            ,
            
                enrollment_date: item.enrollment_date
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const students = await db.students.bulkCreate(studentsData, { transaction });

        // For each item created, replace relation files
        

        return students;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const students = await db.students.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.student_number !== undefined) updatePayload.student_number = data.student_number;
        
        
        if (data.gender !== undefined) updatePayload.gender = data.gender;
        
        
        if (data.date_of_birth !== undefined) updatePayload.date_of_birth = data.date_of_birth;
        
        
        if (data.medical_notes !== undefined) updatePayload.medical_notes = data.medical_notes;
        
        
        if (data.enrollment_date !== undefined) updatePayload.enrollment_date = data.enrollment_date;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await students.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await students.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.school !== undefined) {
            await students.setSchool(
              
              data.school,
              
              { transaction }
            );
        }
        
        if (data.campus !== undefined) {
            await students.setCampus(
              
              data.campus,
              
              { transaction }
            );
        }
        

        
        

        

        return students;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const students = await db.students.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of students) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of students) {
                await record.destroy({transaction});
            }
        });


        return students;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const students = await db.students.findByPk(id, options);

        await students.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await students.destroy({
            transaction
        });

        return students;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const students = await db.students.findOne(
            { where },
            { transaction },
        );

        if (!students) {
            return students;
        }

        const output = students.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        output.student_parent_links_student = await students.getStudent_parent_links_student({
            transaction
        });
        
        
        
        
        output.class_enrollments_student = await students.getClass_enrollments_student({
            transaction
        });
        
        
        
        
        
        output.attendance_records_student = await students.getAttendance_records_student({
            transaction
        });
        
        
        
        output.submissions_student = await students.getSubmissions_student({
            transaction
        });
        
        
        
        output.grade_records_student = await students.getGrade_records_student({
            transaction
        });
        
        
        
        
        
        
        
        output.user = await students.getUser({
            transaction
        });
        
        
        output.school = await students.getSchool({
            transaction
        });
        
        
        output.campus = await students.getCampus({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.schools,
        as: 'school',
        
        where: filter.school ? {
          [Op.or]: [
            { id: { [Op.in]: filter.school.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.school.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.campuses,
        as: 'campus',
        
        where: filter.campus ? {
          [Op.or]: [
            { id: { [Op.in]: filter.campus.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.campus.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.student_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'students',
                        'student_number',
                        filter.student_number,
                    ),
                };
            }
            
            if (filter.medical_notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'students',
                        'medical_notes',
                        filter.medical_notes,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'students',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.date_of_birthRange) {
                const [start, end] = filter.date_of_birthRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    date_of_birth: {
                    ...where.date_of_birth,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    date_of_birth: {
                    ...where.date_of_birth,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.enrollment_dateRange) {
                const [start, end] = filter.enrollment_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    enrollment_date: {
                    ...where.enrollment_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    enrollment_date: {
                    ...where.enrollment_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.gender) {
                where = {
                    ...where,
                gender: filter.gender,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.students.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'students',
                        'student_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.students.findAll({
            attributes: [ 'id', 'student_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['student_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.student_number,
        }));
    }

    
};

